// COPYRIGHT 


#ifndef KPP_COMMAND_DOHALFTURN_H
#define KPP_COMMAND_DOHALFTURN_H

/*****************************************
 INCLUDES
*******************************************/

#include <iostream>

#include "kppInterfaceWalk/kppInterfaceWalk.h"

#include "KineoController/kppCommand.h"

KIT_PREDEF_CLASS( CkppCommandDoHalfTurn );


/*****************************************
 CLASS
*******************************************/

class CkppCommandDoHalfTurn : public CkppCommand
{

public:

	enum EParameters
	{
		PARAMETER_COUNT
	};

	static CkppCommandDoHalfTurnShPtr   create(CkppInterfaceWalk *kpp);

	static CkppCommandDoHalfTurnShPtr   createCopy(const CkppCommandDoHalfTurnConstShPtr& i_command);

	virtual ~CkppCommandDoHalfTurn();

	virtual ktStatus doExecute();

	virtual bool	isUndoable() const;

	virtual CkppCommandShPtr clone() const;

	virtual unsigned int	countParameters() const;

	virtual CkppParameterConstShPtr	parameter(unsigned int i_rank) const;

protected:

	CkppCommandDoHalfTurn(CkppInterfaceWalk *kpp);

	CkppCommandDoHalfTurn(const CkppCommandDoHalfTurn& i_command);

	ktStatus init(const CkppCommandDoHalfTurnWkPtr& i_weakPtr);

private:

	CkppCommandDoHalfTurnWkPtr m_weakPtr;

	CkppInterfaceWalk *attKpp;

};

#endif
