// COPYRIGHT 



#ifndef KPP_COMMAND_OUTPUT_MOTION_H
#define KPP_COMMAND_OUTPUT_MOTION_H

/*****************************************
 INCLUDES
*******************************************/

#include <iostream>

#include "kppInterfaceWalk/kppInterfaceWalk.h"

#include "KineoController/kppCommand.h"

KIT_PREDEF_CLASS( CkppCommandOutputMotion );


/*****************************************
 CLASS
*******************************************/

class CkppCommandOutputMotion : public CkppCommand
{

public:

	enum EParameters {
	  PATH = 0,
	  PARAMETER_COUNT
	};

	static CkppCommandOutputMotionShPtr   create(CkppInterfaceWalk *kpp);

	static CkppCommandOutputMotionShPtr   createCopy(const CkppCommandOutputMotionConstShPtr& i_command);
	
	virtual ~CkppCommandOutputMotion();
	
	virtual ktStatus doExecute();

	virtual bool	isUndoable() const;

	virtual CkppCommandShPtr clone() const;

	virtual unsigned int	countParameters() const;

	virtual CkppParameterConstShPtr	parameter(unsigned int i_rank) const;

protected:

	CkppCommandOutputMotion(CkppInterfaceWalk *kpp);

	CkppCommandOutputMotion(const CkppCommandOutputMotion& i_command);

	ktStatus init(const CkppCommandOutputMotionWkPtr& i_weakPtr);

private:

	CkppCommandOutputMotionWkPtr m_weakPtr;

	CkppInterfaceWalk *attKpp;

};

#endif
