
/*****************************************
 INCLUDES
*******************************************/


#include "kppInterfaceWalk/kppCommandDoHalfTurn.h"

#include "KineoController/kppSetPropertyCommand.h"
#include "KineoModel/kppComponentParameter.h"
#include "KineoModel/kppValue.h"
#include "KineoModel/kppComponentClassFilter.h"
#include "KineoModel/kppComponent.h"
#include "KineoModel/kppSolidComponent.h"

/*****************************************
 DEFINES
*******************************************/

/*****************************************
 METHODS
*******************************************/



// ==========================================================================

CkppCommandDoHalfTurn::CkppCommandDoHalfTurn(CkppInterfaceWalk *kpp)
{
  attKpp = kpp;
}


// ==========================================================================

CkppCommandDoHalfTurn::CkppCommandDoHalfTurn(const CkppCommandDoHalfTurn& i_command) :
  CkppCommand(i_command)
{
  attKpp = i_command.attKpp;
}


// ==========================================================================

CkppCommandDoHalfTurn::~CkppCommandDoHalfTurn()
{
  
}


// ==========================================================================

CkppCommandDoHalfTurnShPtr CkppCommandDoHalfTurn::create(CkppInterfaceWalk *kpp)
{
  CkppCommandDoHalfTurn*  ptr = new CkppCommandDoHalfTurn(kpp);
  CkppCommandDoHalfTurnShPtr shPtr(ptr);
  
  if(KD_OK != ptr->init(shPtr))
    {
      shPtr.reset();
    }

  return shPtr;
}

// ==========================================================================

CkppCommandDoHalfTurnShPtr CkppCommandDoHalfTurn::createCopy(const CkppCommandDoHalfTurnConstShPtr& i_command)
{
  CkppCommandDoHalfTurn*  ptr = new CkppCommandDoHalfTurn(*i_command);
  CkppCommandDoHalfTurnShPtr shPtr(ptr);
  
  if(KD_OK != ptr->init(shPtr))
    {
      shPtr.reset();
    }
  
  return shPtr;
}


// ==========================================================================

ktStatus CkppCommandDoHalfTurn::init(const CkppCommandDoHalfTurnWkPtr& i_weakPtr)
{
  ktStatus success = CkppCommand::init(i_weakPtr);
  
  if(KD_OK == success)
	{
	  m_weakPtr = i_weakPtr;
	}

  return success;
}


// ==========================================================================


CkppCommandShPtr CkppCommandDoHalfTurn::clone() const
{
  return CkppCommandDoHalfTurn::createCopy(m_weakPtr.lock());
}


// ==========================================================================

bool CkppCommandDoHalfTurn::isUndoable() const
{
  return true;
}


// ==========================================================================

unsigned int CkppCommandDoHalfTurn::countParameters() const
{
  return PARAMETER_COUNT;
}


// ==========================================================================

CkppParameterConstShPtr CkppCommandDoHalfTurn::parameter(unsigned int i_rank) const
{
 
  CkppParameterShPtr result;
  CkppComponentShPtr nullComponent;

  switch(i_rank)
    {   
    default:
      KPP_ASSERT( false );
    }
  
  return result;
}


// ==========================================================================

ktStatus CkppCommandDoHalfTurn::doExecute()
{

  // get the Value of DoHalfturn
  bool val =  attKpp->hppWalkPlanner()->doHalfTurn() ;

  if (val == true){
    attKpp->hppWalkPlanner()->doHalfTurn(false) ;
    cout << "attDoHalfTurn is now FALSE" << endl ;
  }
  else{
    attKpp->hppWalkPlanner()->doHalfTurn(true) ;
    cout << "attDoHalfTurn is now TRUE" << endl ;
  }

  return KD_OK ;
 
}


// ==========================================================================
