// COPYRIGHT 

/*
*
*
*  DO NOT WRITE IN THIS FILE
*
*
*
*/



/*****************************************
 INCLUDES
*******************************************/


#include "kppInterfaceWalk/kppCommandLoadObstacle.h"

#include "KineoController/kppSetPropertyCommand.h"
#include "KineoModel/kppComponentParameter.h"
#include "KineoModel/kppValue.h"
#include "KineoModel/kppComponentClassFilter.h"
#include "KineoModel/kppComponent.h"
#include "KineoModel/kppSolidComponent.h"

/*****************************************
 DEFINES
*******************************************/

/*****************************************
 METHODS
*******************************************/



// ==========================================================================

CkppCommandLoadObstacle::CkppCommandLoadObstacle(CkppInterfaceWalk* kpp)
{
  attKpp = kpp;
}


// ==========================================================================

CkppCommandLoadObstacle::CkppCommandLoadObstacle(const CkppCommandLoadObstacle& i_command) :
  CkppPlanPathCommand(i_command)
{
  attKpp = i_command.attKpp;
}


// ==========================================================================

CkppCommandLoadObstacle::~CkppCommandLoadObstacle()
{
  
}


// ==========================================================================

CkppCommandLoadObstacleShPtr CkppCommandLoadObstacle::create(CkppInterfaceWalk *kpp)
{
  CkppCommandLoadObstacle*  ptr = new CkppCommandLoadObstacle(kpp);
  CkppCommandLoadObstacleShPtr shPtr(ptr);
  
  if(KD_OK != ptr->init(shPtr))
    {
      shPtr.reset();
    }

  return shPtr;
}

// ==========================================================================

CkppCommandLoadObstacleShPtr CkppCommandLoadObstacle::createCopy(const CkppCommandLoadObstacleConstShPtr& i_command)
{
  CkppCommandLoadObstacle*  ptr = new CkppCommandLoadObstacle(*i_command);
  CkppCommandLoadObstacleShPtr shPtr(ptr);
  
  if(KD_OK != ptr->init(shPtr))
    {
      shPtr.reset();
    }
  
  return shPtr;
}


// ==========================================================================

ktStatus CkppCommandLoadObstacle::init(const CkppCommandLoadObstacleWkPtr& i_weakPtr)
{
  ktStatus success = CkppPlanPathCommand::init(i_weakPtr);
  
  if(KD_OK == success)
	{
	  m_weakPtr = i_weakPtr;
	}

  return success;
}


// ==========================================================================


CkppCommandShPtr CkppCommandLoadObstacle::clone() const
{
  return CkppCommandLoadObstacle::createCopy(m_weakPtr.lock());
}


// ==========================================================================

bool CkppCommandLoadObstacle::isUndoable() const
{
  return true;
}


// ==========================================================================

unsigned int CkppCommandLoadObstacle::countParameters() const
{
  return PARAMETER_COUNT;
}


// ==========================================================================

CkppParameterConstShPtr CkppCommandLoadObstacle::parameter(unsigned int i_rank) const
{
 
  CkppParameterShPtr result;
  CkppComponentShPtr nullComponent;

  switch(i_rank)
    {   
    default:
      KPP_ASSERT( false );
    }
  
  return result;
}


// ==========================================================================

ktStatus CkppCommandLoadObstacle::doExecute()
{

  std::cerr << "CkppCommandLoadObstacle::doExecute: please do not send yourself Corba requests." << std::endl;

  // this causes trouble for python
  // orb->destroy();

  return KD_ERROR ;
 
}


// ==========================================================================
